<%@ LANGUAGE="VBSCRIPT"%>
<%Option Explicit%>
<%
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'	Version 1.24
'	Original Code: Paul T. Walchli (http://home.att.net/~p.walchli/)
' 	Adapted to be a reusable page by: Hunter Beanland (hbeanland@yahoo.com.au)
'	There's some dead code here, and it's a bit messy in this version - but it works!
'	See readme.htm for full instructions
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Const ColourBack = "lightgray"
Const ColourFore = "#0000cc"
CONST conSeries = 0
CONST conValue = 1
CONST conValueName = 2
CONST intChartAreaY = 60

Response.AddHeader "Pragma", "No-Cache"
Response.Expires = 0
Response.ContentType = "text/plain"

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

' Common variables
Dim bolFlag, intCounter, intUnitMultiplier, intDifference 'aryValues(), 
Dim intChartAreaX, intChartAreaTop, intChartAreaWidth, intChartAreaHeight
Dim intSVGWidth, intSVGHeight, strMonth, strXMonth, intHashLength
Dim intCurrentValue, intHighValue, intLowValue, intValueRange, intXSpace
Dim conn, rsRecordset, strSQL, intRecCount, OldLCID
Dim strChartName, strChartTitle, strChartType, fillColor, intIncrement
Dim intLightRange, foreRed, foreBlue, foreGreen, strColor
Dim DataElements(), SeriesNames(), SeriesData(), DataTemp, intSeriesCount, intCounter2

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

' Bar chart variables
Dim intBarHeight, intBarYPoint, intBarYSpace, intBarXStart, intBarXEnd
Dim intVertRuleXLocation, intLowestXValue, intHighestXValue, intNumVertRules, intXText
Dim intZeroXPoint, intLowXPoint, strAscDesc
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

' Line chart variables
Dim x_Hashmark, intNumHashmarks, intNextX, intNextY, intNumHorzLines, intExtraHorzLines
Dim y_HorzLine, intLowestYValue, intHighestYValue, intYSpace
Dim intLineYPoint, intYText, intZeroYPoint, intPlaceHolder
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

' Pie chart variables
Dim intXRadius, intYRadius, intXOrigin, intYOrigin, dblRadians
Dim dblXNextPoint, dblYNextPoint, dblXLastPoint, dblYLastPoint, intYLegend
Dim intSumOfValues, intCurrentPercent, intLastPercent, intNumOfValues
Dim intTempStore, intFirstValue, intSecondValue
Dim aryColors() 'arySortedValue(), aryUnsortedValue(), aryColors()

OldLCID = Session.LCID ' Set to US so international numbers are read properly.
Session.LCID = &H0409

Sub StopError(ErrorMessage)
	' Show an error on the chart and halt chart processing
	Response.write("<?xml version=""1.0"" standalone=""no""?>" & vbCrLf)
	Response.write("<svg width=""450"" height=""350"" viewBox=""0 0 450 350"">" & vbCrLf)
	Response.Write("<text x=""1"" y=""20"" style=""font-family:Arial, sans-serif; font-size:12; font-weight:normal; fill:red; text-anchor:start;"">" & vbCrLf)
	Response.Write(ErrorMessage & vbCrLf)
	Response.Write("</text>" & vbCrLf)
	Response.Write("<text x=""1"" y=""40"" style=""font-family:Arial, sans-serif; font-size:10; font-weight:normal; fill:blue; text-anchor:start;"">" & vbCrLf)
	Response.Write("QueryString: ")
	for each intCounter in request.QueryString
		Response.Write(intCounter & "=" & request.QueryString(intCounter) & ";" & vbCrLf)
	next	
	Response.Write("</text>" & vbCrLf)
	Response.Write("</svg>" & vbCrLf)
	response.Write ("<!--" &vbCRLF & "If you can see this then you are not calling this page correctly. Call it from another page with this code (replacing _ with values):" &vbCRLF)
	response.Write ("<object type=""image/svg+xml"" data=""SVGChart.asp?ChartType=_&Width=_&Height=_&ChartName=_&XName=_&YName=_&DataElement1=_&SeriesName1=_&SeriesData1=_"" width=""_"" height=""_""></object>" & vbCRLF & "-->" &vbCRLF) 
	Session.LCID = OldLCID
	response.end
End Sub

' Assign variables to query string values
strChartType = Request.QueryString("ChartType")
'intSVGHeight = 350
bolFlag = False
'response.Write ("<html><body>" & now &"<br>")

'Get the names of the Y axis increment labels
intCounter = 1
while Request.QueryString("DataElement" & cstr(intCounter)) <> ""
	ReDim preserve DataElements(intCounter)
	DataElements(intCounter) = Request.QueryString("DataElement" & cstr(intCounter))
	intCounter = intCounter + 1
wend

'Get the names of each series
intCounter = 1
while Request.QueryString("SeriesName" & cstr(intCounter)) <> ""
	ReDim preserve SeriesNames(intCounter)
	SeriesNames(intCounter) = Request.QueryString("SeriesName" & cstr(intCounter))
	intCounter = intCounter + 1
wend
intSeriesCount = intCounter-1

'Get the data of each series (comma seperated values)
intCounter = 1
ReDim SeriesData(intSeriesCount,1)
while Request.QueryString("SeriesData" & cstr(intCounter)) <> ""
	DataTemp = split(Request.QueryString("SeriesData" & cstr(intCounter)),",")
	for intCounter2 = 0 to ubound(DataTemp)
		if ubound(SeriesData,2) < intCounter2 then ReDim preserve SeriesData(intSeriesCount,intCounter2)
		SeriesData(intCounter,intCounter2) = cdbl(DataTemp(intCounter2))
	next	
	intCounter = intCounter + 1
wend
intRecCount = intCounter2
if intCounter-1 <> intSeriesCount then StopError "The number of SeriesData labels and SeriesName labels must be the same"
if ubound(DataElements) <> intRecCount then StopError "The number of DataElement labels and the number of values in each SeriesData label must be the same"

' ... redim and fill the array w/ three dimensions ...
'ReDim aryValues(3,intRecCount)
ReDim arySortedValues(3, intRecCount), arySortedValue(3, intRecCount)
if intRecCount > 12 then
	ReDim aryColors(intRecCount)
else
	ReDim aryColors(12)
end if
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'Load some standard safe colours in order of each data series first. 
aryColors(0) = "#008000" 	' Dark Green
aryColors(1) = "#ff0000"	' Red
aryColors(2) = "#808080"	' Grey
aryColors(3) = "#000000"	' Black
aryColors(4) = "#0000ff"	' Blue
aryColors(5) = "#800000"	' Maroon
aryColors(6) = "#ff8000"	' Orange
aryColors(7) = "#996600"	' Brown
aryColors(8) = "#ff00ff"	' Fuchsia/Pink
aryColors(9) = "#800080"	' Purple
aryColors(10) = "#008080"	' Teal
aryColors(11) = "#000080"	' Navy
aryColors(12) = "#0080ff"	' Light Blue

' Create a random colours if needed... modified from Noah Gates code.
intLightRange = 256
Randomize
For intCounter = 13 to intRecCount - 1
    foreRed = Int(Rnd * intLightRange) 
    foreGreen = Int(Rnd * intLightRange) 
    foreBlue = Int(Rnd * intLightRange) 
    strColor = "#" & Hex(foreRed) & Hex(foreGreen) & Hex(foreBlue) 
	aryColors(intCounter) = strColor
Next

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' Find high & low values; then value range 
intHighValue = SeriesData(1,0)
intLowValue = intHighValue
For intCounter2 = 1 to intSeriesCount
	For intCounter = 0 to intRecCount-1
		If intHighValue <= SeriesData(intCounter2,intCounter) Then
			intHighValue = SeriesData(intCounter2,intCounter)
		End If
		If intLowValue >= SeriesData(intCounter2,intCounter) Then
			intLowValue = SeriesData(intCounter2,intCounter)
		End If
	Next
Next
'response.Write ("<br>HighLow="& intHighValue &":"& intLowValue & "<br>")

' Find the range between the high & low values. From this, determine the 
' 	increments between the values along the y axis.
intValueRange = intHighValue - intLowValue
If intValueRange >= 0 And intValueRange <= 1 Then intIncrement = 0.1
If intValueRange > 1 And intValueRange <= 5 Then intIncrement = 0.5
If intValueRange > 5 And intValueRange <= 10 Then intIncrement = 1
If intValueRange > 10 And intValueRange <= 20 Then intIncrement = 2
If intValueRange > 20 And intValueRange <= 50 Then intIncrement = 5
If intValueRange > 50 And intValueRange <= 100 Then intIncrement = 10
If intValueRange > 100 And intValueRange <= 200 Then intIncrement = 20
If intValueRange > 200 And intValueRange <= 400 Then intIncrement = 50
If intValueRange > 400 And intValueRange <= 1000 Then intIncrement = 100
If intValueRange > 1000 And intValueRange <= 2000 Then intIncrement = 200
If intValueRange > 2000 And intValueRange <= 10000 Then intIncrement = 1000
If intValueRange > 10000 And intValueRange <= 100000 Then intIncrement = 10000
If intValueRange > 100000 And intValueRange <= 1000000 Then intIncrement = 100000


'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'#																						#
'#									BEGIN LINE CHART									#
'#																						#
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

If strChartType = "Line" Then

' Set the dimensions ...
intChartAreaTop = 45
intChartAreaHeight = cint(request.QueryString("Height"))-125
intChartAreaWidth = cint(request.QueryString("Width")) -60
intChartAreaX = 50
intHashLength = 10

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' Initialize intYText with the value of the increment amount and compare it to
' 	the lowest value in the array. If it is the value stored in intYText is 
'	lower than the lowest value in the array, then increment intYText by the
' 	increment amount until intYText is larger than the lowest array value.
'	If intYText is greater, then decrement it. Either will be adjusted below
' 	if intYtext is greater than 0 (zero).
intYText = intIncrement
If intYText < intLowValue Then
	Do Until intYText >= intLowValue
		intYText = intYText + intIncrement
	Loop
End If
If intYText > intLowValue Then
	Do Until intYText =< intLowValue
		intYText = intYText - intIncrement
	Loop
End If

' Adjustment if needed
If intYText > 0 Then
	intYText = intYText - intIncrement 
End If
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' Depending on what values are stored in intIncrement, extra horizontal lines may be needed. 
If intIncrement <= 1 Then
	intExtraHorzLines = 2
ElseIf intIncrement > 1 And intIncrement <=50 Then
	intExtraHorzLines = 1
Else
	intExtraHorzLines = 0
End If

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' Determine the number of horizontal rules and units between each to be rendered.
intCounter = 0
intPlaceHolder = intLowValue - intIncrement
Do Until intPlaceHolder > intHighValue
	intPlaceHolder = intPlaceHolder + intIncrement
	intCounter = intCounter + 1
Loop
intNumHorzLines = intCounter + intExtraHorzLines
intYSpace = intChartAreaHeight / intNumHorzLines

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' Begin writing the svg tags ...
Response.write("<?xml version=""1.0"" standalone=""no""?>" & vbCrLf)

' Set the dimensions of the SVG image and viewBox coordinates. Disable zoom & pan.
Response.write("<svg width=""" & request.QueryString("Width") & """ height='"& request.QueryString("Height") &"' viewBox=""0 0 " & request.QueryString("Width") & " '"& request.QueryString("Height") &"'"" zoomAndPan=""enable"">" & vbCrLf)

' Draw a border around the entire SVG image
Response.write("	<rect x=""0"" y=""0"" width=""" & request.QueryString("Width") & """ height='"& request.QueryString("Height") &"' style=""fill:none; stroke:black; stroke-width:2;""/>" & vbCrLf)

' Render the chart title 
Response.Write(" <text x='"& cint(request.QueryString("Width")) \ 2 &"' y=""25"" style=""font-family:Arial, sans-serif; font-size:18; font-weight:normal; fill:black; text-anchor:middle;"">" & vbCrLf)
Response.Write(request.QueryString("ChartName") & vbCrLf)
Response.Write(" </text>" & vbCrLf)

' Render chart background (solid)
Response.write("	<rect x='"& intChartAreaX &"' y='"& intChartAreaTop &"' width='"& intChartAreaWidth &"' height='"& intChartAreaHeight &"' style=""fill:" & ColourBack & "; stroke:none; stroke-width:2;""/>" & vbCrLf)

' Render the horizontal lines using a path element
y_HorzLine = (intChartAreaTop + intChartAreaHeight)  ' set base of line chart
For intCounter = 0 to intNumHorzLines
	Response.write("<path d=""M40,"& y_HorzLine &" L40,"& y_HorzLine & " " & intChartAreaWidth+intChartAreaX & " " & y_HorzLine &""" style=""stroke-width:1; stroke:none; fill:" & ColourFore & ";""/>" & vbCrLf)
	y_HorzLine = y_HorzLine - intYSpace
Next

' Reset the y_HorzLine variable & render the text along the y axis
y_HorzLine =  (intChartAreaTop + intChartAreaHeight) ' set base of line chart
For intCounter = 0 to intNumHorzLines
	Response.write("<text x=""35"" y='"& y_HorzLine &"' style=""text-anchor:end; fill:" & ColourFore & "; font-family:Arial, sans-serif; font-size:10;"">" & vbCrLf)
	Response.write(intYText & vbCrLf)
	Response.write("</text>" & vbCrLf)
	If intCounter = 0 Then

' First time through, set the value of intLowestYValue to the first y 
' 	location a horizontal line is rendered and "zero" point.
		intLowestYValue = intYText

' Set the flag to true ... used below
		bolFlag = True
	End If
	If intYText = 0 Then

' If the value of intYText = 0, then render the horizontal rule red and set the 
' 	"zero" location to that of the current y_HorzLine.
		'Response.write("<path d=""M40,"& y_HorzLine &" L40,"& y_HorzLine &" 440,"& y_HorzLine &""" style=""stroke-width:2; stroke:red; fill:none;""/>" & vbCrLf)
		intZeroYPoint = y_HorzLine 
	End If

' Increment the value stored in intYText to the next to be rendered.
	intYText = intYText + intIncrement

' Increment or "move" the horizontal rule location to the its next position.
	y_HorzLine = y_HorzLine - intYSpace
Next

' Set the value for the highest value rendered on the y axis by subtracting	the 
' 	increment amount from the last intYText rendered.
intHighestYValue = intYText - intIncrement

' Get the difference between the highest and lowest values rendered on the x axis ...
intDifference = intHighestYValue - intLowestYValue

' 	... then divide the chart area by the difference to find the number	of "units" 
' 	to be used as a multiplier to determine the y location of a value.
intUnitMultiplier = FormatNumber(intChartAreaHeight / intDifference, 5)

' If the flag is set to true, recalculate the zero point.
If bolFlag = True Then
	intZeroYPoint = (intLowestYValue * intUnitMultiplier) + (intChartAreaTop + intChartAreaHeight)
End If

' Render the x axis hashmarks.
intNumHashmarks = intRecCount '+ 1

' Find the amount of space between each element rendered on the x axis. With half a space on each side.
intXSpace = intChartAreaWidth / (intNumHashmarks-1)

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' Render the hashmarks ... first, middle, last
'Response.write("<path d=""M"& intChartAreaX &","& intChartAreaTop + intChartAreaHeight + intHashLength &" L"& intChartAreaX &","& intChartAreaTop + intChartAreaHeight + intHashLength &" "& intChartAreaX &","& intChartAreaTop + intChartAreaHeight &""" style=""stroke-width:1; stroke:" & ColourFore & "; fill:none;""/>" & vbCrLf)

' Add one move of hashmark
x_Hashmark = intChartAreaX
For intCounter = 0 to intNumHashmarks - 1
	Response.write("<path d=""M"& x_Hashmark &","& intChartAreaTop + intChartAreaHeight + intHashLength &" L"& x_Hashmark &","& intChartAreaTop + intChartAreaHeight + intHashLength &" "& x_Hashmark &","& intChartAreaTop + intChartAreaHeight &""" style=""stroke-width:1; stroke:none; fill:" & ColourFore & ";""/>" & vbCrLf)
	x_Hashmark = x_Hashmark + intXSpace
Next

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' Reset hashmark for text render the text and values along the x axis
x_Hashmark = intChartAreaX
For intCounter = 0 to intNumHashmarks - 1

	Response.write("<text x='"& x_Hashmark &"' y='"& intChartAreaHeight + 65 &"' style=""font-family:Arial, sans-serif; font-size:10; font-weight:normal; fill:" & ColourFore & "; text-anchor:middle;"">"& DataElements(intCounter+1) & "</text>" & vbCrLf)
	'Response.Write("<text x='"& x_Hashmark &"' y='"& intChartAreaHeight + 80 &"' style=""font-family:Arial, sans-serif; font-size:9; font-weight:normal; fill:black; text-anchor:middle;"">"& aryValues(conValue,intCounter) & "</text>" & vbCrLf)

' Increment the hashmark location
x_Hashmark = x_Hashmark + intXSpace
Next

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' Write the Series Names along the x axis
x_Hashmark = intChartAreaHeight + intChartAreaTop + 35
intCounter2 = intChartAreaX
For intCounter = 0 to intSeriesCount - 1
	Response.write("<text x='"& intCounter2 &"' y='"& x_Hashmark &"' style=""font-family:Arial, sans-serif; font-size:10; font-weight:normal; fill:" & aryColors(intCounter) & "; text-anchor:start;"">"& SeriesNames(intCounter+1) & "</text>" & vbCrLf)
	' Increment the y offset location
	x_Hashmark = x_Hashmark + 10
	if x_Hashmark+4 > cint(request.QueryString("Height")) then
		x_Hashmark = intChartAreaHeight + intChartAreaTop + 35
		intCounter2 = intCounter2 +100
	end if
Next

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' Write the y and x axis names
Response.write(" <text x='" & (intChartAreaWidth+intChartAreaX+10) \ 2 & "' y='" & intChartAreaHeight + intChartAreaTop + 40 & "' style=""font-family:Arial, sans-serif; font-size:10; font-weight:normal; fill:" & ColourFore & "; text-anchor:middle;"">" & vbCrLf)
Response.write(""& request.QueryString("XName") &"" & vbCrLf)
Response.write(" </text>" & vbCrLf)
Response.write(" <defs>" & vbCrLf & "<path id='yaxispath' d='M 5 " & vbCrLf & intChartAreaHeight \2+10 & " L 5 " & intChartAreaHeight+intChartAreaTop-10 & "' />" & vbCrLf & "</defs>" & vbCrLf)
'Response.write(" <text x='5' y='" & intChartAreaTop-10 & "' style=""font-family:Arial, sans-serif; font-size:11; font-weight:normal; fill:" & ColourFore & "; text-anchor:start;"">" & vbCrLf)
Response.write(" <text style=""font-family:Arial, sans-serif; font-size:10; font-weight:normal; fill:" & ColourFore & "; text-anchor:middle;"">" & vbCrLf)
Response.write(" <textPath xlink:href='#yaxispath' style=""glyph-orientation-vertical:90; font-family:Arial, sans-serif; font-size:10; font-weight:normal; fill:" & ColourFore & "; text-anchor:start;"">" & vbCrLf)
Response.write(""& request.QueryString("YName") &"" & vbCrLf)
Response.write(" </textPath>" & vbCrLf & "</text>" & vbCrLf)

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' Render the lines & circles; reset hashmark
intLightRange = 0
For intCounter2 = 1 to intSeriesCount
	x_Hashmark = intChartAreaX
	For intCounter = 0 to intNumHashmarks - 1
			intLineYPoint = intZeroYPoint - (SeriesData(intCounter2,intCounter) * intUnitMultiplier)
			If intCounter < (intNumHashmarks - 1) Then
				intNextX = x_Hashmark + intXSpace
				intNextY = intZeroYPoint - (SeriesData(intCounter2,intCounter + 1) * intUnitMultiplier)
				Response.write("<path d=""M"& x_Hashmark &","& intLineYPoint &" L"& x_Hashmark &","& intLineYPoint &" "& intNextX &","& intNextY &""" style=""stroke-width:2; stroke:" & aryColors(intLightRange) & "; fill:none;""/>" & vbCrLf)
			End If
			Response.write("<circle cx='"& x_Hashmark &"' cy='"& intLineYPoint &"' r=""3"" style=""stroke-width:none; stroke:none; fill:" & aryColors(intLightRange) & ";"">" & vbCrLf)
			Response.write("</circle>" & vbCrLf)
		x_Hashmark = x_Hashmark + intXSpace
	Next
	intLightRange = intLightRange +1
Next
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

' Close the SVG tag
Response.Write("</svg>" & vbCrLf)

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'#																						#
'#									BEGIN BAR CHART										#
'#																						#
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

ElseIf strChartType = "Bar" Then

' Set the dimensions and margins ...
intChartAreaX = 70
intChartAreaTop = intChartAreaY
intChartAreaHeight = cint(request.QueryString("Height"))-120
intChartAreaWidth = cint(request.QueryString("Width")) -95
intBarHeight = 15
intBarYSpace = 10

'If the bars don't fit, squeeze the height so they do
if ((intSeriesCount * intBarHeight + intBarYSpace) * intRecCount) > intChartAreaHeight then
	intBarHeight = (intChartAreaHeight / intRecCount - intBarYSpace) / intSeriesCount
end if

intVertRuleXLocation = intChartAreaX

' Set a new width ... work on this
intSVGWidth = intChartAreaX + intChartAreaWidth + 25

Response.write("<?xml version=""1.0"" standalone=""no""?>" & vbCrLf)

' Set the dimensions of the SVG image and viewBox coordinates. 
Response.write("<svg width='"& request.QueryString("Width") &"' height='"& request.QueryString("Height") &"' viewBox=""0 0 "& request.QueryString("Width") &" "& request.QueryString("Height") &""" zoomAndPan=""enable"">" & vbCrLf)

' Determine the number of vertical rules to be rendered.
intNumVertRules = Fix(intValueRange / intIncrement) + 2

' Find the number of units between each element along the x axis within the chart area.
intXSpace = FormatNumber((intChartAreaWidth / intNumVertRules), 4)

' Initialize intXText and adjust its value up or down as appropriate
intXText = 0

If intXText < intLowValue Then
	Do Until intXText > intLowValue
		intXText = intXText + intIncrement
	Loop
End If
If intXText > intLowValue Then
	Do Until intXText < intLowValue
		intXText = intXText - intIncrement
	Loop
End If

' Set intLowestXValue to the first value rendered on the x axis. 
intLowestXValue = intXText

' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' Assign the chart title string and render it.
Response.Write(" <text x='"& cint(request.QueryString("Width")) \ 2 &"' y=""25"" style=""font-family:Arial, sans-serif; font-size:12; font-weight:normal; fill:black; text-anchor:middle;"">" & vbCrLf)
Response.Write(request.QueryString("ChartName") & vbCrLf)
Response.Write(" </text>" & vbCrLf)

' Render the border for the SVG image.
Response.Write("<rect x=""0"" y=""0"" width='"& request.QueryString("Width") &"' height='"& request.QueryString("Height") &"' style=""fill:none; stroke:black;""/> 	" & vbCrLf)

' Render chart border.
Response.Write("<rect x='"& intChartAreaX &"' y='"& intChartAreaY &"' width='"& intChartAreaWidth &"' height='"& cint(request.QueryString("Height")) - (intChartAreaY * 2) &"' style=""fill:"& ColourBack &"; stroke:none;""/> 	" & vbCrLf)

' Render the vertical lines along the x axis. If "zero" is rendered, change 
' 	the line's strColor to red and the value of bolFlag to True to indicate 
' 	intZeroXPoint must be modified below.
For intCounter = 0 to intNumVertRules
	If intXText = 0 Then
		Response.Write("<path d=""M"& intVertRuleXLocation &","& cint(request.QueryString("Height")) - (intChartAreaY - 5) &" L"& intVertRuleXLocation &","& cint(request.QueryString("Height")) - (intChartAreaY - 5) &" "& intVertRuleXLocation &","& intChartAreaY - 5 &" "" style=""fill:"& ColourFore & "; stroke:none; stroke-width:2;""/> 	" & vbCrLf)
		intZeroXPoint = intVertRuleXLocation
		bolFlag = True
		Else
		Response.Write("<path d=""M"& intVertRuleXLocation &","& cint(request.QueryString("Height")) - (intChartAreaY - 5) &" L"& intVertRuleXLocation &","& cint(request.QueryString("Height")) - (intChartAreaY - 5) &" "& intVertRuleXLocation &","& intChartAreaY - 5 &" "" style=""fill:"& ColourFore & "; stroke:none; stroke-width:2;""/> 	" & vbCrLf)
	End If

' First time through, set the value of intXLowPoint to the first x location  
' 	a vertical line is rendered.
	If intCounter = 0 Then
		intLowXPoint = intVertRuleXLocation
	End If

' Render the incremented values along the top and bottom of the x axis.
	Response.Write("<text x='"& intVertRuleXLocation &"' y='"& intChartAreaY - 10 &"' style=""font-family:Arial, sans-serif; font-size:10; font-weight:normal; fill:"& ColourFore & "; text-anchor:middle;"">"& intXText &"</text>" & vbCrLf)
	Response.Write("<text x='"& intVertRuleXLocation &"' y='"& cint(request.QueryString("Height")) - intChartAreaY + 20 &"' style=""font-family:Arial, sans-serif; font-size:10; font-weight:normal; fill:"& ColourFore & "; text-anchor:middle;"">"& intXText &"</text>" & vbCrLf)

' Increment or "move" the vertical rule location to the its next position.
	intVertRuleXLocation = intVertRuleXLocation + intXSpace

' Increment the value stored in intXText to the next to be rendered.
	intXText = intXText + intIncrement
Next

' Set the value for the highest value rendered on the x axis by subtracting
' 	the increment amount from the last intXText rendered.
intHighestXValue = intXText - intIncrement

' Get the difference between the highest and lowest values rendered on the x axis ...
intDifference = intHighestXValue - intLowestXValue 

' 	... then divide the chart area by the difference to find the number
' 	of "units" to be used as a multiplier to determine the x location of a value.
intUnitMultiplier = FormatNumber(intChartAreaWidth / intDifference, 5)

' If the bolFlag was not changed above, then set the "zero" location
' 	on the x axis either the highest value (farthest right of the chart)
' 	or the lowest value (farthest left of the chart).
If bolFlag = False Then
	If intHighestXValue < 0 Then

' Set farthest right ...
		intZeroXPoint = intVertRuleXLocation - intXSpace
	Else

' ... set farthest left.
		intZeroXPoint = FormatNumber(intLowestXValue * intUnitMultiplier,4)
	End If
End If

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' Write the y and x axis names
Response.write(" <text x='" & (intChartAreaWidth+intChartAreaX+10) \ 2 & "' y='" & intChartAreaHeight + intChartAreaTop + 40 & "' style=""font-family:Arial, sans-serif; font-size:10; font-weight:normal; fill:" & ColourFore & "; text-anchor:middle;"">" & vbCrLf)
Response.write(""& request.QueryString("XName") &"" & vbCrLf)
Response.write(" </text>" & vbCrLf)
Response.write(" <text x='5' y='" & intChartAreaTop-10 & "' style=""font-family:Arial, sans-serif; font-size:10; font-weight:normal; fill:" & ColourFore & "; text-anchor:start;"">" & vbCrLf)
Response.write(""& request.QueryString("YName") &"" & vbCrLf)
Response.write(" </text>" & vbCrLf)
' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' Set the top left corner of the first bar. The below is determined by the 
' 	y location of the top of the chart area, plus half of the spacing between
' 	each bar on the y axis. This produces even spacing between the 5 bars
' 	to be rendered. 
intBarYPoint = intChartAreaTop + (intBarYSpace / 2)

' Start rendering the bars
For intCounter = 0 to intRecCount - 1 
' Display each record of each series (group by series)
	' Write the group/unit name
	Response.Write("<text x='"& 8 &"' y='"& intBarYPoint - 1 &"' fill=""" & ColourFore & """ style=""font-family:Arial, sans-serif; font-size:10; font-weight:normal; text-anchor:start;"">"& DataElements(intCounter+1) &"</text>" & vbCrLf)
For intCounter2 = 0 to intSeriesCount - 1

fillColor = aryColors(intCounter2)

' If the lowest value rendered is GREATER than 0 (zero) use this formula:
	If intLowestXValue > 0 Then
		intBarXStart = intChartAreaX
		intBarXEnd = Abs((FormatNumber((SeriesData(intCounter2+1,intCounter) * intUnitMultiplier) - (intZeroXPoint),5)))
		Response.Write("<rect x='"& intBarXStart &"' y='"& intBarYPoint &"' width='"& intBarXEnd &"' height='"& intBarHeight &"' fill='"& fillColor &"' style=""stroke:none;""> 	" & vbCrLf)
		Response.Write("</rect>" & vbCrLf)

' If the lowest value rendered is EQUAL to 0 (zero) use this formula:
	ElseIf intLowestXValue = 0 Then
		intBarXStart = intChartAreaX
		intBarXEnd = Abs((FormatNumber((SeriesData(intCounter2+1,intCounter) * intUnitMultiplier),5)))
		Response.Write("<rect x='"& intBarXStart &"' y='"& intBarYPoint &"' width='"& intBarXEnd &"' height='"& intBarHeight &"' fill='"& fillColor &"' style=""stroke:none;""> 	" & vbCrLf)
		Response.Write("</rect>" & vbCrLf)
	ElseIf intLowestXValue < 0 And intHighestXValue > 0 Then

' If the lowest value is LESS than 0 (zero) AND the highest value is
' 	GREATER than 0 (zero) then use this nested If statement ...
		If SeriesData(intCounter2+1,intCounter) >= 0 Then

' If the current value being evaluated is GREATER or EQUAL to 0 (zero) 	then use this formula:
			intBarXStart = intZeroXPoint
			intBarXEnd = intChartAreaX + (FormatNumber((SeriesData(intCounter2+1,intCounter) * intUnitMultiplier) - (intLowestXValue * intUnitMultiplier) - intZeroXPoint,4))
			Response.Write("<rect x='"& intBarXStart &"' y='"& intBarYPoint &"' width='"& intBarXEnd &"' height='"& intBarHeight &"' fill='"& fillColor &"' style=""stroke:none;""> 	" & vbCrLf)
			Response.Write("</rect>" & vbCrLf)
		ElseIf SeriesData(intCounter2+1,intCounter) < 0 Then

' If the current value being evaluated is LESS than 0 (zero) then use this formula:
			intBarXStart = intChartAreaX + Abs(FormatNumber(((intLowestXValue - SeriesData(intCounter2+1,intCounter)) * intUnitMultiplier),4)) 
			intBarXEnd = intZeroXPoint - intBarXStart
			Response.Write("<rect x='"& intBarXStart &"' y='"& intBarYPoint &"' width='"& intBarXEnd &"' height='"& intBarHeight &"' fill='"& fillColor &"' style=""stroke:none;""> 	" & vbCrLf)
			Response.Write("</rect>" & vbCrLf)
		End If

' ... else the last option is that the highest value is LESS than 0 (zero), 
' 	which makes the lowest value also less than 0 (zero). Use this formula:
	Else ' intHighestXValue <= 0
		intBarXStart = intChartAreaX + Abs(FormatNumber(((intLowestXValue - SeriesData(intCounter2+1,intCounter)) * intUnitMultiplier),4)) 
		intBarXEnd = intZeroXPoint - intBarXStart
		Response.Write("<rect x='"& intBarXStart &"' y='"& intBarYPoint &"' width='"& intBarXEnd &"' height='"& intBarHeight &"' fill='"& fillColor &"' style=""stroke:none;""> 	" & vbCrLf)
		Response.Write("</rect>" & vbCrLf)
	End If
	Response.Write("<text x='"& intChartAreaX-8 &"' y='"& intBarYPoint + 11 &"' fill=""black"" style=""font-family:Arial, sans-serif; font-size:10; font-weight:normal; text-anchor:end;"">"& SeriesNames(intCounter2+1) &"</text>" & vbCrLf)
	'Response.Write("<text x='"& intChartAreaX - 10 &"' y='"& intBarYPoint + 11 &"' fill=""black"" style=""font-family:Arial, sans-serif; font-size:8; font-weight:normal; text-anchor:end;"">"& SeriesData(1,intCounter) &"</text>" & vbCrLf)

' Increment or "move" the y location for the next bar element.
	intBarYPoint = intBarYPoint + intBarHeight
Next
	'Start of next unit
	intBarYPoint = intBarYPoint + intBarYSpace
Next

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

' Close the SVG tag
Response.Write("</svg>" & vbCrLf)


'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'#																						#
'#									BEGIN PIE CHART										#
'#																						#
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

ElseIf strChartType = "Pie" Then

' Set origins, radius
intXOrigin = cint(request.QueryString("Width")) \ 2
intYOrigin = cint(request.QueryString("Height")) \ 2
' Keep it round
if intXOrigin > intYOrigin then
	intXRadius = intYOrigin -40
	intYRadius = intYOrigin -40
else
	intXRadius = intXOrigin -40
	intYRadius = intXOrigin -40
end if

intLastPercent = 0 ' place holder for current percentage

' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' Sort user entered values and make absolute
For intFirstValue = 0 To intRecCount - 1 
	If SeriesData(1, intFirstValue) < 0 then SeriesData(1, intFirstValue) = abs(SeriesData(1, intFirstValue))
    For intSecondValue = intFirstValue To intRecCount -1
		If SeriesData(1, intSecondValue) < 0 then SeriesData(1, intSecondValue) = abs(SeriesData(1, intSecondValue))
	    If SeriesData(1, intFirstValue) < SeriesData(1, intSecondValue) Then
		    intTempStore = SeriesData(1, intFirstValue)
		    SeriesData(1, intFirstValue) = SeriesData(1, intSecondValue)
		    SeriesData(1, intSecondValue) = intTempStore
		    intTempStore = DataElements(intFirstValue+1)
		    DataElements(intFirstValue+1) = DataElements(intSecondValue+1)
		    DataElements(intSecondValue+1) = intTempStore
	    End if 'firstArray < intSecondValue
    Next 
Next 

' Determine sum of all values and total number of values
For intCounter = 0 to UBound(SeriesData,2) '- 1 'jamie remarked "-1" here 2004-06-16
	intSumOfValues = intSumOfValues + SeriesData(1, intCounter)
	intNumOfValues = intNumOfValues + 1
Next

' Error check numbers that are way less than 1% of the pie
'For intCounter = 0 to intRecCount - 1
'	If (arySortedValue(conValue, intCounter) / intSumOfValues) < 0.01 Then
'		alert "One of your values is less than 1% of the total pie. That's too small for this example."
'	End If
'Next

' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' Begin writing the SVG tags ...
Response.Write("<?xml version=""1.0"" standalone=""no""?>" & vbCrLf)
' Set the dimensions of the SVG image and viewBox coordinates ...
Response.write("<svg width='"& request.QueryString("Width") &"' height='"& request.QueryString("Height") &"' viewBox=""0 0 "& request.QueryString("Width") &" "& request.QueryString("Height") &""">" & vbCrLf)
Response.Write("<rect x='"& 0 &"' y='"& 0 &"' width="""& request.QueryString("Width") &""" height="""& request.QueryString("Height") &""" fill=""none"" style=""stroke:black; stroke-width:0;""/>" & vbCrLf)
' Render chart title
Response.Write(" <text x='"& intXOrigin &"' y=""100"" style=""font-family:Arial, sans-serif; font-size:12; font-weight:normal; fill:black; text-anchor:middle;"">" & vbCrLf)
Response.Write(request.QueryString("ChartName") & vbCrLf)
Response.Write(" </text>" & vbCrLf)

' Render chart legend ...
' 	... set the y location of the first element ...
intYLegend = 20
For intCounter = 0 to intRecCount - 1
	Response.Write("<rect x='"& 10 &"' y='"& intYLegend &"' width=""10"" height=""10"" fill='"& aryColors(intCounter) &"' style=""stroke:none; stroke-width:none;""/>" & vbCrLf)
'	... add 5 units to intYLegend to account for the height of the rectangle ...
	Response.Write(" <text x='"& 25 &"' y='"& intYLegend+10 &"' style=""font-family:Arial, sans-serif; font-size:10; font-weight:normal; fill:black;"">" & vbCrLf)
	Response.Write(DataElements(intCounter+1) & ": "& SeriesData(1, intCounter) &"" & vbCrLf)
	Response.Write(" </text>" & vbCrLf)
'	... and increment or "move" the y location of the next element(s).
intYLegend = intYLegend + 15
Next

' Create group for pie
Response.Write("<g>" & vbCrLf)
' Build the pie.
For intCounter = 0 to intRecCount - 1 
' Determine the percentage.
	intCurrentPercent = intCurrentPercent + FormatNumber((SeriesData(1, intCounter) / intSumOfValues), 3) * 100
' Can't display anything less than about 0.3% of a pie
if (SeriesData(1, intCounter) / intSumOfValues) >= 0.003 then
' Multiply intCurrentPercent by 3.6 (which equals 1/100 of 360 of a circle) to find the 
' number of degrees this slice of pie is and add that number to the last percentage.
	intCurrentPercent = (intCurrentPercent * 3.6) + intLastPercent
' Determines the dblRadians based on the percentage * 3.6 above.
	dblRadians = intCurrentPercent * (3.14159/180)
	dblRadians = FormatNumber(dblRadians, 4)
' Solve for the X Y coordinates based on the dblRadians (found above) within the plane.
	dblXNextPoint = (intXRadius * Cos(dblRadians)) + intXOrigin
	dblYNextPoint = (intYRadius * Sin(dblRadians)) + intYOrigin
	If intCounter = 0 Then
' First time through, create a circle for what will be the largest value (slice) rendered.
		Response.Write("<ellipse cx='"& intXOrigin &"' cy='"& intYOrigin &"' rx=""" & intXRadius & """ ry=""" & intYRadius & """ style=""fill:"& aryColors(intCounter) &"; stroke:black; stroke-width:0.5;"" />" & vbCrLf)
	Else
' Render the remaining slices.
		Response.Write("<path style=""fill:"& aryColors(intCounter) &"; stroke:black; stroke-width:0.5;"" d=""M"& dblXLastPoint &","& dblYLastPoint &" A"& intXRadius &","& intYRadius &" 0 0,1 "& dblXNextPoint &","& dblYNextPoint &" L"& intXOrigin &","& intYOrigin &" "& dblXLastPoint &","& dblYLastPoint &""" />" & vbCrLf)
	End If
' Set the place holders and reset the current percent (needed).
	dblXLastPoint = dblXNextPoint
	dblYLastPoint = dblYNextPoint
	intLastPercent = intCurrentPercent
	intCurrentPercent = 0
end if
Next

' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' Close the tags
Response.Write("</g>" & vbCrLf)
Response.Write("</svg>" & vbCrLf)

Else
	'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	StopError "Invalid chart type..."
End If
Session.LCID = OldLCID
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
%>
